<?php

/*********************************************************************

 拍手アーカイブ表示プラグイン (2017/08/27)

  freo.jp
  32877|http://32877.xii.jp

*********************************************************************/

/* メイン処理 */
function freo_display_clap_archive()
{
	global $freo;

	//検索条件設定
	$condition = null;

	//予定取得
	if (FREO_DATABASE_TYPE == 'mysql') {
		$stmt = $freo->pdo->prepare('SELECT DATE_FORMAT(created, \'%Y-%m\') AS month, COUNT(*) AS count FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps ' . $condition . ' GROUP BY month ORDER BY month DESC');
	} else {
		$stmt = $freo->pdo->prepare('SELECT STRFTIME(\'%Y-%m\', created) AS month, COUNT(*) AS count FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps ' . $condition . ' GROUP BY month ORDER BY month DESC');
	}
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$archives = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		if (preg_match('/^(\d\d\d\d)\-(\d\d)$/', $data['month'], $matches)) {
			$archives[] = array(
				'year'  => $matches[1],
				'month' => $matches[2],
				'count' => $data['count']
			);
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_clap_archives' => $archives
	));

	return;
}

?>
