<?php

/*********************************************************************

 拍手アーカイブプラグイン (2017/08/27)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_page_clap_archive()
{
	global $freo;

	switch ($_REQUEST['freo']['work']) {
		case 'admin':
			freo_page_clap_archive_admin();
			break;
	}

	return;
}

/* 管理画面 | 拍手管理 */
function freo_page_clap_archive_admin()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//パラメータ検証
	if (!isset($_GET['day']) or !preg_match('/^\d\d\d\d\d\d$/', $_GET['day'])) {
		$_GET['day'] = date('Ym');
	}

	//拍手タイトル取得
	if (FREO_DATABASE_TYPE == 'mysql') {
		$stmt = $freo->pdo->prepare('SELECT title, COUNT(*) AS count FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE DATE_FORMAT(created, \'%Y%m\') = :day AND title IS NOT NULL GROUP BY title ORDER BY title');
	} else {
		$stmt = $freo->pdo->prepare('SELECT title, COUNT(*) AS count FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE STRFTIME(\'%Y%m\', created) = :day AND title IS NOT NULL GROUP BY title ORDER BY title');
	}
	$stmt->bindValue(':day', $_GET['day']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_clap_titles = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_clap_titles[] = $data;
	}

	//拍手時間取得
	if (FREO_DATABASE_TYPE == 'mysql') {
		$stmt = $freo->pdo->prepare('SELECT DATE_FORMAT(created, \'%H\') AS hour, COUNT(*) AS count, session FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE DATE_FORMAT(created, \'%Y%m\') = :day GROUP BY hour, session ORDER BY id');
	} else {
		$stmt = $freo->pdo->prepare('SELECT STRFTIME(\'%H\', created) AS hour, COUNT(*) AS count, session FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE STRFTIME(\'%Y%m\', created) = :day GROUP BY hour, session ORDER BY id');
	}
	$stmt->bindValue(':day', $_GET['day']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_clap_hours  = array();
	$plugin_clap_counts = array('count' => 0, 'session' => array());
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		if (isset($plugin_clap_hours[$data['hour']])) {
			$plugin_clap_hours[$data['hour']]['count'] += $data['count'];
			$plugin_clap_hours[$data['hour']]['session'][$data['session']] = true;
		} else {
			$plugin_clap_hours[$data['hour']] = array(
				'hour'    => $data['hour'],
				'count'   => $data['count'],
				'session' => array($data['session'] => true)
			);
		}

		$plugin_clap_counts['count'] += $data['count'];
		$plugin_clap_counts['session'][$data['session']] = true;
	}
	// 拍手時間を時間の昇順で並び替え
	$hour = array();
	foreach ($plugin_clap_hours as $key => $value) {
	  $hour[$key] = $value['hour'];
	}
	array_multisort($hour, SORT_ASC, $plugin_clap_hours);

	// 拍手タイトルを回数の降順で並び替え
	$count = array();
	foreach ($plugin_clap_titles as $key => $value) {
	  $count[$key] = $value['count'];
	}
	array_multisort($count, SORT_DESC, $plugin_clap_titles);

	//拍手メッセージ取得
	if (isset($_GET['hour'])) {
		$plugin_clap_texts = array();
	} else {
		if (isset($_GET['title']) and $_GET['title'] != '') {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE DATE_FORMAT(created, \'%Y%m\') = :day AND title = :title AND text IS NOT NULL ORDER BY id');
			} else {
				$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE STRFTIME(\'%Y%m\', created) = :day AND title = :title AND text IS NOT NULL ORDER BY id');
			}
			$stmt->bindValue(':day',   $_GET['day']);
			$stmt->bindValue(':title', $_GET['title']);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}
		} else {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE DATE_FORMAT(created, \'%Y%m\') = :day AND text IS NOT NULL ORDER BY id');
			} else {
				$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_claps WHERE STRFTIME(\'%Y%m\', created) = :day AND text IS NOT NULL ORDER BY id');
			}
			$stmt->bindValue(':day', $_GET['day']);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}
		}

		$plugin_clap_texts = array();
		while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
			$plugin_clap_texts[$data['id']] = $data;
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'              => freo_token('create'),
		'plugin_clap_archive_hours'  => $plugin_clap_hours,
		'plugin_clap_archive_counts' => $plugin_clap_counts,
		'plugin_clap_archive_titles' => $plugin_clap_titles,
		'plugin_clap_archive_texts'  => $plugin_clap_texts
	));

	return;
}

?>
